#!/usr/bin/env python3

import ctypes
from ctypes import *
from enum import Enum
from pydbus import SystemBus

class KdkModuleType(Enum):
    KDK_MODULE_ACCOUNT = 0                      #账户安全
    KDK_MODULE_APPLICATION = 1                  #应用安全
    KDK_MODULE_DATA = 2                         #数据安全
    KDK_MODULE_DESKTOP = 3                      #桌面管控
    KDK_MODULE_DEVICE = 4                       #设备安全
    KDK_MODULE_FILE = 5                         #文件安全（防篡改）
    KDK_MODULE_NETWORK = 6                      #网络安全
    KDK_MODULE_PROCESS = 7                      #进程安全
    KDK_MODULE_USERAUTH = 8                     #用户身份识别
    KDK_MODUlE_LOG = 9                          #安全SDK日志
    KDK_MODULE_SECDAEMON = 10                   #安全SDK初始化
    KDK_MODULE_APPLICATION_SYSSECRISKBOX = 11   #应用安全system风险提示服务
    KDK_MODULE_MAX = 12

class KdkAccessCtlStatus(Enum):
    KDK_ACCESSCTL_DISABLE = 0      #禁止访问
    KDK_ACCESSCTL_ENABLE = 1       #允许访问

class KdkAccessCtlErrnoStatus(Enum):
    KDK_ERRNO_ACCESSCTL_DENY = -5000    #门禁管控禁止访问

 
class KdkAccessCtl:
    def __init__(self):
        try:
            self.libaccessctl = ctypes.CDLL("libkyaccessctl.so")
            self.dbus = SystemBus().get("org.freedesktop.DBus", "/org/freedesktop/DBus")

        except Exception:
            exit(-1)

    def kdk_accessctl_check_callable_nosender(self, pid, uid, type):
        rc = self.libaccessctl.kdkaccessctl_check_callable_dbus(uid, pid, type)
        return rc

    def kdk_accessctl_check_callable(self, sender, type):
        if sender != None:
            pid = self.dbus.GetConnectionUnixProcessID(sender)
            uid = self.dbus.GetConnectionUnixUser(sender)
            
            rc = self.libaccessctl.kdkaccessctl_check_callable_dbus(uid, pid, type)
            return rc

        return KdkAccessCtlStatus.KDK_ACCESSCTL_DISABLE
